using System.Collections.Generic;

namespace Bowling
{
    public class BowlingGame
    {
        public BowlingGame()
        {
            Frames = new List<Frame>();
        }

        public const int FRAMES_COUNT = 10;

        string scoreCard;
        public string ScoreCard
        {
            get { return scoreCard; }
            set 
            { 
                scoreCard = value;
                for(var i=0;i<FRAMES_COUNT*2;i=i+2)
                {
                    var frame = new Frame();
                    frame.Roll1 = value[i];
                    frame.Roll2 = value[i + 1];
                    Frames.Add(frame);
                }

                if(value.Length==FRAMES_COUNT*2+1)
                    Frames.Add(new BonusFrame {Roll1=value[FRAMES_COUNT*2]});
                if (value.Length == FRAMES_COUNT * 2 + 2)
                    Frames.Add(new BonusFrame { Roll1 = value[FRAMES_COUNT * 2],Roll2=value[FRAMES_COUNT*2+1] });
            }
        }

        public List<Frame> Frames { get; set;}

        public int Score
        {
            get
            {
                var score = 0;
                for(var i=0;i<FRAMES_COUNT;i++)
                {
                    score += Frames[i].Score;
                    if (Frames[i].IsSpare)
                        score += Frames[i + 1].Roll1.ParseAsInt();
                    else if (Frames[i].IsStrike)
                    {
                        if (!Frames[i + 1].IsStrike || Frames[i + 1] is BonusFrame)
                            score += Frames[i + 1].Score;
                        else
                            score += Frames[i + 1].Score + Frames[i + 2].Roll1.ParseAsInt();
                    }

                }

                return score;
            }
        }
    }
}