namespace Bowling
{
    public class Frame
    {
        public char Roll1;
        public char Roll2;

        public bool IsSpare
        {
            get
            { return Roll2 == '/'; }
        }

        public bool IsStrike
        {
            get
            {
                return Roll1 == 'x';
            }
        }

        public virtual int Score
        {
            get
            {
                if (IsSpare || IsStrike)
                    return 10;
                return Roll1.ParseAsInt() + Roll2.ParseAsInt();
            }
        }
    }

    public class BonusFrame : Frame
    {
        public override int Score
        {
            get
            {
                return Roll1.ParseAsInt() + Roll2.ParseAsInt();
            }
        }
    }
}