﻿using System.Linq;
using System.Text;
using Machine.Specifications;

namespace Bowling
{
    /*
     Frame, Roll, Bowling Game, 

in a bowling game 
	-when a player scores no spares or strikes
		-score for game is the total of all frame scores
	-when a player scores a single spare
		-score for game is the sum of all frames plus the score for subsequent throw
	-when a player scores a single strike
		-score for game is sum of all frames plus the the score for subsequent 2 throws
	-when a player scores a spare in the 10th frame
		-score for game is sum of ten frames plus score for 1 extra throw
	-when a player scores a strike in the 10th frame
		-score for game is sum of ten frames plus score for 2 extra throws
	-when a player scores a golden game
		-score for game is 300

     */

    public class in_a_bowling_game
    {
        public static BowlingGame game;

        Establish context = () => game = new BowlingGame();
    }

    public class when_a_player_scores_no_spares_or_strikes : in_a_bowling_game
    {
        Because of = () => game.ScoreCard = "11111111111111111111";

        It score_for_game_is_the_total_of_all_frame_scores
            = () => game.Score.ShouldEqual(20);
    }

    public class when_a_player_scores_a_single_spare : in_a_bowling_game
    {
        Because of = () => game.ScoreCard = "--4/51--------------";

        It score_for_game_is_the_sum_of_all_frames_plus_the_score_for_subsequent_throw
            = () => game.Score.ShouldEqual(21);

    }

    public class when_a_player_scores_a_single_strike : in_a_bowling_game
    {
        Because of = () => game.ScoreCard = "--x-51--------------";

        It score_for_game_is_sum_of_all_frames_plus_the_the_score_for_subsequent_2_throws
                = () => game.Score.ShouldEqual(22);

    }

    public class when_a_player_scores_a_spare_in_the_10th_frame : in_a_bowling_game
    {
        Because of = () => game.ScoreCard = "------------------4/6";

        It score_for_game_is_sum_of_ten_frames_plus_score_for_1_extra_throw
                = () => game.Score.ShouldEqual(16);
    }

    public class when_a_player_scores_a_strike_in_the_10th_frame : in_a_bowling_game
    {
        Because of = () => game.ScoreCard = "------------------x-61";

        It score_for_game_is_sum_of_ten_frames_plus_score_for_2_extra_throws
                    = () => game.Score.ShouldEqual(17);
    }

    public class when_a_player_scores_a_golden_game : in_a_bowling_game
    {
        Because of = () => game.ScoreCard = "xxxxxxxxxxxxxxxxxxxxxx";

        It score_for_game_is_300
                        = () => game.Score.ShouldEqual(300);

    }

}
